﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Dynamic;
using System.Web;
using System.Web.Mvc;
using GridDemo.Models;

namespace GridDemo.Controllers
{
    [HandleError]
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            ViewData["Message"] = "Welcome to ASP.NET MVC!";

            return View();
        }

        public ActionResult About()
        {
            return View();
        }

        public ActionResult GridDemo()
        {
            return View();
        }

        public ActionResult GridDemoData(int page, int rows, string search, string sidx, string sord)
        {
            var repository = new Repository();
            var model = from entity in repository.SelectAll().OrderBy(sidx + " " + sord)
                        select new
                        {
                            IntProperty = entity.IntProperty,
                            StringProperty = entity.StringProperty,
                            DateProperty = entity.DateProperty.ToString(System.Globalization.CultureInfo.CurrentUICulture)
                        };
            return Json(model.ToJqGridData(page, rows, null, search,
                new[] { "IntProperty", "StringProperty", "DateProperty" }));
        }

        public ActionResult TreeDemo()
        {
            return View();
        }
    }
}
